; #########################################################################

    .386
    .model flat, stdcall    

    option casemap : none ; case sensitive

; #########################################################################
  
    IMalloc     PROTO
    Alloc       PROTO :DWORD
    Realloc     PROTO :DWORD, :DWORD
    GetSize     PROTO :DWORD
    Free        PROTO :DWORD

    .code

; #########################################################################

    TEST_DD_BLOCK1 equ 4000000h ; size of dd array to   allocate, around  64Mb
    TEST_DD_BLOCK2 equ 8000000h ; size of dd array to reallocate, around 128Mb

    start:
    ;{
        int     3

        invoke  Alloc, TEST_DD_BLOCK1
        mov     ebx, eax

        ; ebx holds a pointer to 64Mb of uninitialized, allocated memory

        invoke  GetSize, ebx
        cmp     eax, TEST_DD_BLOCK1

        ; zero flag is set, showing that the size is truly 64Mb

        mov     eax, 12345678h
        mov     edi, ebx           
        mov     ecx, TEST_DD_BLOCK1 / 4
        cld
        rep     stosd

        ; all the memory has now been initialized to 12345678h

        invoke  Realloc, ebx, TEST_DD_BLOCK2

        ; the ebx pointer is no longer a valid one
        ; a new array has been allocated and holds the old values
        ; the rest of the array is initialised with zeroes

        mov     ebx, eax

        ; ebx now holds a pointer to 128Mb, first 64Mb being the old memory buffer

        invoke  GetSize, ebx
        cmp     eax, TEST_DD_BLOCK2

        ; size is a.o.k.

        mov     eax, 02468ACEh
        mov     edi, ebx           
        mov     ecx, TEST_DD_BLOCK2 / 4
        cld
        rep     stosd

        ; all the memory has now been initialized to 02468ACEh

        invoke  Free, ebx

        ; the ebx pointer is no longer a valid, memory has been released

        xor     eax, eax
        ret
    ;}
    end start
